define("jquery/ui/tabbable", [
    "jquery"
    , "jquery/ui/focusable"
    , "jquery/ui/version"
], function (jQuery) {

/*!
 * jQuery UI Tabbable 1.12.1
 * http://jqueryui.com
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 */

//>>label: :tabbable Selector
//>>group: Core
//>>description: Selects elements which can be tabbed to.
//>>docs: http://api.jqueryui.com/tabbable-selector/

(function( $, undefined ) {

return $.extend( $.expr[ ":" ], {
    tabbable: function( element ) {
        var tabIndex = $.attr( element, "tabindex" ),
            hasTabindex = tabIndex != null;
        return ( !hasTabindex || tabIndex >= 0 ) && $.ui.focusable( element, hasTabindex );
    }
} );

})( jQuery );


    return jQuery;
});