/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'de_epages/mediagallery/filemanager',

    '$ready!'
], function (QUnit, $, Filemanager) {

    QUnit.module('de_epages/mediagallery/filemanager', {
        setup: function () {
            var node = $('<div id="fileManager" />').appendTo('#qunit-fixture'),

                // fake data for ajax requests
                initArray = [{
                    "currentGallerySize": "1344",
                    "children": [{
                        "files": [{
                            "width": null,
                            "extension": ".swf",
                            "name": "promo.swf",
                            "path": "/promo.swf",
                            "height": null,
                            "directory": "/MediaGallery",
                            "modified": 1200994146,
                            "size": 67089,
                            "fullpath": "/WebRoot/Store/Shops/DemoShop/MediaGallery/promo.swf",
                            "selectable": 0,
                            "mimetype": "application/x-shockwave-flash"
                        }, {
                            "width": "240",
                            "extension": ".gif",
                            "name": "StartPagePromotion.gif",
                            "path": "/StartPagePromotion.gif",
                            "height": "113",
                            "directory": "/MediaGallery",
                            "modified": 1200994146,
                            "size": 14453,
                            "preview": "/WebRoot/Store/Shops/DemoShop/MediaGallery/StartPagePromotion.gif",
                            "fullpath": "/WebRoot/Store/Shops/DemoShop/MediaGallery/StartPagePromotion.gif",
                            "selectable": 1,
                            "mimetype": "image/gif"
                        }],
                        "children": [{
                            "files": [],
                            "children": [],
                            "metadata": {
                                "displayname": "neu",
                                "type": "MediaGallery",
                                "path": "/neu"
                            },
                            "data": "neu",
                            "state": null
                        }],
                        "metadata": {
                            "displayname": "MediaGallery",
                            "type": "MediaGallery",
                            "path": ""
                        },
                        "data": "MediaGallery",
                        "state": "closed"
                    }, {
                        "files": [],
                        "children": [{
                            "files": [],
                            "children": [],
                            "metadata": {
                                "displayname": "Kunst, Kultur und Bildung",
                                "type": "Header",
                                "path": "/StyleGroups/Branches/StyleGroups/ArtAndEducation"
                            },
                            "data": "ArtAndEducation",
                            "state": null
                        }, {
                            "files": [],
                            "children": [],
                            "metadata": {
                                "displayname": "Auto und Transport",
                                "type": "Header",
                                "path": "/StyleGroups/Branches/StyleGroups/Automotive"
                            },
                            "data": "Automotive",
                            "state": null
                        }],
                        "metadata": {
                            "displayname": "Kopfzeilenbilder",
                            "type": "Header",
                            "path": "/StyleGroups/Branches/StyleGroups"
                        },
                        "data": "HeaderImages",
                        "state": "closed"
                    }, {
                        "files": [],
                        "children": [{
                            "files": [],
                            "children": [],
                            "metadata": {
                                "displayname": "Kunst, Kultur und Bildung",
                                "type": "Background",
                                "path": "/StyleGroups/Branches/StyleGroups/ArtAndEducation"
                            },
                            "data": "ArtAndEducation",
                            "state": null
                        }],
                        "metadata": {
                            "displayname": "Hintergrundbilder",
                            "type": "Background",
                            "path": "/StyleGroups/Branches/StyleGroups"
                        },
                        "data": "BackgroundImages",
                        "state": "closed"
                    }, {
                        "files": [],
                        "children": [{
                            "files": [],
                            "children": [],
                            "metadata": {
                                "displayname": "Gebäude",
                                "type": "ImageDB",
                                "path": "/ImageDBGroups/Buildings"
                            },
                            "data": "Buildings",
                            "state": null
                        }],
                        "metadata": {
                            "displayname": "{ImageDB}",
                            "type": "ImageDB",
                            "path": "ImageDBGroups"
                        },
                        "data": "ImageDB",
                        "state": "closed"
                    }],
                    "maxGallerySize": "102400"
                }],
                filemanager;

            // fake ep.ajax
            $.ajax = function (o) {
                var result = $.Deferred();

                if (o.data.ViewAction === "JSONInitMediaGallery") {
                    result.resolve(initArray);
                }

                return result;
            };

            // create file manager
            filemanager = Filemanager.init({element: node});
        }
    });

    QUnit.test('view methods', function () {
        $.each(['init'], function (i, method) {
            QUnit.strictEqual(
                $.isFunction(Filemanager[method]),
                true,
                method + ' is a method of list view'
            );
        });

        QUnit.strictEqual(
            $('.ep-mediagallery').length,
            1,
            'Create filemanager and append it to container'
        );
    });
});